%%
% %RUL estimation - data preparation
batch1 = load('2017-05-12_batchdata_updated_struct_errorcorrect.mat');
% batch2 = load('2017-06-30_batchdata_updated_struct_errorcorrect.mat');
% batch3 = load('2018-04-12_batchdata_updated_struct_errorcorrect.mat');
% 
% cell_num = 1;
% 
% while cell_num < 47
%     batch1.batch(cell_num).cycles(1) = [];
%     batch1.batch(cell_num).summary.cycle(1) = [];
%     batch1.batch(cell_num).summary.QDischarge(1) = [];
%     cell_num = cell_num + 1;
% end
% % 
% batch = batch3.batch;
% batch(24).cycle_life = 2190;
% batch(33).cycle_life = 2238;
% 
% 
% batch = [batch2.batch batch];
% batch(118).cycle_life = 2190;
% batch(127).cycle_life = 2238;
%%
%Training set (80%)
SetIndex = 1;
[trainInd,valInd,testInd] = dividerand(46+48-3,0.8,0.1,0.1);
TrainingsetRUL = [];
dQdVmin = [];

while SetIndex < max(size(trainInd))
    cycle_num = 1;
    cycle_life = size(batch(trainInd(SetIndex)).summary.cycle);
    
    while cycle_num < cycle_life(1) + 1
        
        [dQ_min,dV_min_index] = min(batch(trainInd(SetIndex)).cycles(cycle_num).discharge_dQdV(1:end-100));
        dQdVmin = [dQdVmin ; dQ_min dV_min_index];
        cycle_num = cycle_num + 1;

    end
    RUL = abs(batch(trainInd(SetIndex)).summary.cycle - (max(cycle_life) )) ; 
    TrainingsetRUL = [TrainingsetRUL; batch(trainInd(SetIndex)).summary.cycle batch(trainInd(SetIndex)).summary.QDischarge batch(trainInd(SetIndex)).summary.IR RUL];
    SetIndex = SetIndex + 1;
end

TrainingsetRUL = [dQdVmin TrainingsetRUL];
%%
%Validation set (10%)

SetIndex = 1;
ValidationsetRUL = [];
dQdVmin = [];

while SetIndex < max(size(valInd))
    cycle_num = 1;
    cycle_life = size(batch(valInd(SetIndex)).summary.cycle);
    
    while cycle_num < cycle_life(1) + 1      
        [dQ_min,dV_min_index] = min(batch(valInd(SetIndex)).cycles(cycle_num).discharge_dQdV(1:end-100));
        dQdVmin = [dQdVmin ; dQ_min dV_min_index];
        cycle_num = cycle_num + 1;
    end
    
    RUL = abs(batch(valInd(SetIndex)).summary.cycle+1 - (max(cycle_life))) ; 
    ValidationsetRUL = [ValidationsetRUL; batch(valInd(SetIndex)).summary.cycle batch(valInd(SetIndex)).summary.QDischarge batch(valInd(SetIndex)).summary.IR RUL];
    SetIndex = SetIndex + 1;
end

ValidationsetRUL = [dQdVmin ValidationsetRUL];
%%
%Test set (10%)

SetIndex = 1;
TestsetRUL = [];
dQdVmin = [];

while SetIndex < max(size(testInd))
    cycle_num = 1;
    cycle_life = size(batch(testInd(SetIndex)).summary.cycle);
    while cycle_num < cycle_life(1) + 1    
        [dQ_min,dV_min_index] = min(batch(testInd(SetIndex)).cycles(cycle_num).discharge_dQdV(1:end-100));
        dQdVmin = [dQdVmin ; dQ_min dV_min_index];
        cycle_num = cycle_num + 1;
    end
    RUL = abs(batch(testInd(SetIndex)).summary.cycle+1 - (max(cycle_life))); 
    TestsetRUL = [TestsetRUL; batch(testInd(SetIndex)).summary.cycle batch(testInd(SetIndex)).summary.QDischarge batch(testInd(SetIndex)).summary.IR RUL];
    SetIndex = SetIndex + 1;
end

TestsetRUL = [dQdVmin TestsetRUL];
    

%%
mu = mean([TrainingsetRUL ; ValidationsetRUL ; TestsetRUL]);
sig = std([TrainingsetRUL ; ValidationsetRUL ; TestsetRUL]);

dataTrainStandardized = (TrainingsetRUL - mu) ./ sig;
mean(dataTrainStandardized)

XTrain = dataTrainStandardized(1:end-1,1:3);
YTrain = dataTrainStandardized(1:end-1,4:6);

XTrain = XTrain';
YTrain = YTrain';

dataValidation = (ValidationsetRUL - mu) ./ sig;
mean(dataValidation)

XValidation = dataValidation(1:end-1, 1:3);
YValidation = dataValidation(1:end-1, 4:6);

XValidation = XValidation';
YValidation = YValidation';

