SetIndex = 7;
TestsetRUL_singlecell = [];
dQdVmin = [];
cycle_num = 1;
cycle_life = size(batch(testInd(SetIndex)).summary.cycle);
    
while cycle_num < cycle_life(1) + 1
        
    [dQ_min,dV_min_index] = min(batch(testInd(SetIndex)).cycles(cycle_num).discharge_dQdV(1:end-100));
    dQdVmin = [dQdVmin ; dQ_min dV_min_index];
    cycle_num = cycle_num + 1;

end
RUL = abs(batch(testInd(SetIndex)).summary.cycle +1 - (max(cycle_life))); 
TestsetRUL_singlecell = [dQdVmin batch(testInd(SetIndex)).summary.cycle batch(testInd(SetIndex)).summary.QDischarge batch(testInd(SetIndex)).summary.IR RUL];


dataTestStandardized = (TestsetRUL - mu) ./ sig;

XTest = dataTestStandardized(1:end-1, 1:3);
YTest = dataTestStandardized(1:end-1, 4:6);

XTest = XTest';
YTest = YTest';

dataTestStandardized_singlecell = (TestsetRUL_singlecell - mu) ./ sig;

XTest_singlecell = dataTestStandardized_singlecell(1:end-1, 1:3);
YTest_singlecell = dataTestStandardized_singlecell(1:end-1, 4:6);

XTest_singlecell = XTest_singlecell';
YTest_singlecell=  YTest_singlecell';

%%
%Run the test
[net,YPred] = predictAndUpdateState(net,XTest);

YTest = YTest';
YPred= YPred';
%Denormalize the test data and the predicted data
RULTest = YTest(:,3) .* sig(6) + mu(6);
RULPred = ceil(YPred(:,3) .* sig(6) + mu(6));

IRTest = YTest(:,2) .* sig(5) + mu(5);
IRPred = (YPred(:,3) .* sig(5) + mu(5));

SOHTest = (YTest(:,1) .* sig(4) + mu(4))/1.1 * 100;
SOHPred = (YPred(:,1) .* sig(4) + mu(4))/1.1 * 100;

error_mae_RUL = mean(abs(RULTest-RULPred));
error_RMSE_RUL = sqrt(mean((RULTest-RULPred).^2));
R_squre_RUL = 1 - sum((RULTest-RULPred).^2) / sum((RULTest-sig(6)).^2);
fprintf('RUL MAE= %g, RMSE= %g, R= %g, MAX= %g\n',...,
     error_mae_RUL,error_RMSE_RUL,R_squre_RUL, max(abs(RULTest-RULPred)));

error_mae_SOH = mean(abs(SOHTest-SOHPred));
error_RMSE_SOH = sqrt(mean((SOHTest-SOHPred).^2));
Rsquare_SOH = 1 - sum((SOHTest-SOHPred).^2) / sum((SOHTest-sig(4)).^2);
fprintf('SOH MAE= %g, RMSE= %g, R= %g, MAX= %g\n', ...,
    error_mae_SOH,error_RMSE_SOH,Rsquare_SOH, max(abs(SOHTest-SOHPred)));

error_mae_IR = mean(abs(abs(IRTest-IRPred)));
error_RMSE_IR = sqrt(mean((IRTest-IRPred).^2));
Rsquare_IR = 1 - sum((IRTest-IRPred).^2) / sum((IRTest-sig(5)).^2);


[net,YPred_singlecell] = predictAndUpdateState(net,XTest_singlecell);

YTest_singlecell = YTest_singlecell';
YPred_singlecell= YPred_singlecell';

%Denormalize the test data and the predicted data
RULTest_singlecell = YTest_singlecell(:,3) .* sig(6) + mu(6);
RULPred_singlecell = ceil(YPred_singlecell(:,3) .* sig(6) + mu(6));

IRTest_singlecell = 1000*(YTest_singlecell(:,2) .* sig(5) + mu(5));
IRPred_singlecell = 1000*(YPred_singlecell(:,2) .* sig(5) + mu(5));

SOHTest_singlecell = (YTest_singlecell(:,1) .* sig(4) + mu(4))/1.1 * 100;
SOHPred_singlecell = (YPred_singlecell(:,1) .* sig(4) + mu(4))/1.1 * 100;

%%
close all;
figure()
plot(RULTest_singlecell(1:end),'LineWidth',3);
hold on
plot(RULPred_singlecell(1:end),'-','LineWidth',3);
legend('Truth','Prediction'); grid on;
xlabel('Cycle number');
ylabel('RUL');
set(gca,'FontSize',14)

figure()
plot(abs((RULTest_singlecell(1:end)-RULPred_singlecell(1:end))),'LineWidth',3);
xlabel('Cycle number'); ylabel('Error');
grid on;
set(gca,'FontSize',14)

figure()
plot(SOHTest_singlecell(1:end),'LineWidth',3);
hold on
plot(SOHPred_singlecell(1:end),'-','LineWidth',3);
legend('Truth','Estimation'); grid on;
xlabel('Cycle number');
ylabel('SOH(%)');
ylim([80 100]);
set(gca,'FontSize',14)

figure()
plot(abs(SOHTest_singlecell(1:end)-SOHPred_singlecell(1:end)),'LineWidth',3);
xlabel('Cycle number'); ylabel('Error(%)');
grid on;
ylim([0 5]);
set(gca,'FontSize',14)

figure()
plot(IRTest_singlecell(1:end),'LineWidth',3);
hold on
plot(IRPred_singlecell(1:end),'LineWidth',3);
legend('Truth','Estimation'); grid on;
xlabel('Cycle number');
ylabel('Internal resistance (m$\Omega$)','interpreter','latex');
set(gca,'FontSize',14)

figure()
plot(abs(IRTest_singlecell(1:end)-IRPred_singlecell(1:end)),'LineWidth',3);
xlabel('Cycle number'); ylabel('Error (m$\Omega$)','interpreter','latex');
grid on;
set(gca,'FontSize',14)


