%Neural Network 

numFeatures = 3;
numResponses = 3;
numHiddenUnits = 23;

layers = [ ...
    sequenceInputLayer(numFeatures)
    lstmLayer(numHiddenUnits)
    fullyConnectedLayer(numResponses)
    regressionLayer];


options = trainingOptions('adam', ...
    'MaxEpochs',300, ...
    'MiniBatchSize',64, ...
    'InitialLearnRate',0.005, ...
    'Shuffle', 'never', ...
    'L2Regularization',0.5, ...
    'LearnRateSchedule','piecewise', ...
    'ValidationData',{XValidation,YValidation}, ...
    'LearnRateDropPeriod',150, ...
    'LearnRateDropFactor',0.1, ...
    'ValidationFrequency',20, ...
    'Verbose',0, ...
    'Plots','training-progress', ...
    'ExecutionEnvironment','gpu');

%Start Training

 net = trainNetwork(XTrain,YTrain,layers,options);