%%
% Load the batch data, and delete cell 38 cause there's problem with it

US06 = load('data/25degC_US06.mat');
UDDS = load('data/25degC_UDDS.mat');
NN = load('data/25degC_NN.mat');
LA92 = load('data/25degC_LA92.mat');
HWFTb = load('data/25degC_HWFTb.mat');
HWFTa = load('data/25degC_HWFTa.mat');
deg25Cycle1 = load('data/25degC_Cycle_1.mat');
deg25Cycle2 = load('data/25degC_Cycle_2.mat');
deg25Cycle3 = load('data/25degC_Cycle_3.mat');
deg25Cycle4 = load('data/25degC_Cycle_4.mat');

batch = [US06 UDDS NN LA92 HWFTb HWFTa deg25Cycle1 deg25Cycle2 deg25Cycle3 deg25Cycle4];

% batch = [deg25Cycle1 deg25Cycle2 deg25Cycle3 deg25Cycle4 ...
%               deg10Cycle1 deg10Cycle2 deg10Cycle3 deg10Cycle4 ...
%               deg0Cycle1 deg0Cycle2 deg0Cycle3 deg0Cycle4];


trainInd = [1,3,8,9,10];
testInd = [4];
valInd = 2;


%%
%training set
batchNum = 1;
TrainingSet = [];

while batchNum <= max(size(trainInd))
    len = length(batch(trainInd(batchNum)).meas.Ah);
    Q = batch(trainInd(batchNum)).meas.Ah(1:ceil(len)) - min(batch(trainInd(batchNum)).meas.Ah);
    I = batch(trainInd(batchNum)).meas.Current(1:ceil(len));
    V = batch(trainInd(batchNum)).meas.Voltage(1:ceil(len));
    T = batch(trainInd(batchNum)).meas.Battery_Temp_degC(1:ceil(len));
    batchNum = batchNum + 1;
    
    temp = [I V T Q];  
    TrainingSet = [TrainingSet ; temp];
end


%%
%validation set
batchNum = 1;
ValidationSet = [];

while batchNum <= max(size(valInd))
    len = length(batch(valInd(batchNum)).meas.Ah);
    Q = batch(valInd(batchNum)).meas.Ah(1:ceil(len)) - min(batch(valInd(batchNum)).meas.Ah);
    I = batch(valInd(batchNum)).meas.Current(1:ceil(len));
    V = batch(valInd(batchNum)).meas.Voltage(1:ceil(len));
    T = batch(valInd(batchNum)).meas.Battery_Temp_degC(1:ceil(len));
    batchNum = batchNum + 1;
    
    temp = [I V T Q];  
    ValidationSet = [ValidationSet ; temp];
end


%%
%test set
batchNum = 1;
TestSet = [];

while batchNum <= max(size(testInd))
    len = length(batch(testInd(batchNum)).meas.Ah);
    Q = batch(testInd(batchNum)).meas.Ah(1:ceil(len))- min(batch(testInd(batchNum)).meas.Ah);
    I = batch(testInd(batchNum)).meas.Current(1:ceil(len));
    V = batch(testInd(batchNum)).meas.Voltage(1:ceil(len));
    T = batch(testInd(batchNum)).meas.Battery_Temp_degC(1:ceil(len));
    batchNum = batchNum + 1;
    
    temp = [I V T Q];  
    TestSet = [TestSet ; temp];
end



%DataSet = [TrainingSet ; ValidationSet ; TestSet];
DataSet = [TrainingSet ; ValidationSet ; TestSet];

mu = mean(DataSet);
sig = std(DataSet);


%%
%Normalization 
dataTrainStandardized = (TrainingSet - mu) ./ sig;

XTrain = dataTrainStandardized(1:end-1, 1:2);
YTrain = dataTrainStandardized(1:end-1, 4);

XTrain = XTrain';
YTrain = YTrain';

dataValidation = (ValidationSet - mu) ./ sig;

XValidation = dataValidation(1:end-1, 1:2);
YValidation = dataValidation(1:end-1, 4);

XValidation = XValidation';
YValidation = YValidation';