%%
%Test data preparation
dataTestStandardized = (TestSet - mu) ./ sig;
XTest = dataTestStandardized(1:end-1,1:2);
XTest = XTest';
YTest = dataTestStandardized(1:end-1,4);
YTest = YTest';

%%Run the test
[net,YPred1] = predictAndUpdateState(net,XTest);


%%Denormalize the test data and the predicted data
YTest = YTest .* sig(4) + mu(4);
YPred1 = YPred1 .* sig(4) + mu(4);
YPred1 = lowpass(YPred1,1e-5);

Q = max(YTest);

SOCTest = YTest(12:end)./Q*100;
SOCPred = YPred1(12:end)./Q*100;   

error_mae = mean(abs(SOCTest-SOCPred));
error_RMSE = sqrt(mean((SOCTest-SOCPred).^2));
fprintf('MAE=%g%%\n',error_mae);
fprintf('RMSE=%g%%\n',error_RMSE);

close all
subplot(211)
plot(SOCPred,'LineWidth',2);
hold on
plot(SOCTest,'LineWidth',2);
legend('SOCPred','SOCTest');
grid on;
xlabel('Time');
ylabel('SOC(%)');
ylim([0 100]);

subplot(212)
plot(SOCTest-SOCPred,'LineWidth',2);
xlabel('Time');
ylabel('SOC error(%)');
grid on;
% ylim([-5 5]);