%%
%RNN Configuration

numFeatures = 2;
numResponses = 1;
numHiddenUnits = 120;

layers = [ ...
    sequenceInputLayer(numFeatures)
    lstmLayer(numHiddenUnits,'OutputMode','sequence')
    fullyConnectedLayer(numResponses)
    regressionLayer];


options = trainingOptions('adam', ...
    'MaxEpochs',100, ...
    'MiniBatchSize',256, ...
    'InitialLearnRate',0.005, ...
    'Shuffle', 'never', ...
    'LearnRateSchedule','piecewise', ...
    'LearnRateDropPeriod',50, ...
    'LearnRateDropFactor',0.1, ...
    'ValidationFrequency',20, ...
     'ValidationData',{XValidation,YValidation}, ...
    'Verbose',0, ...
    'Plots','training-progress', ...
    'ExecutionEnvironment','gpu');
%'L2Regularization',0.001, ...
%      'ValidationFrequency',20, ...
%      'ValidationData',{XValidation,YValidation}, ...


%%
%Start Training

 net = trainNetwork(XTrain,YTrain,layers,options);