%Maximum discharge current
z_min = 0.1;
deltaT = 100;
deltat = 0.1;
R = model.RParam;
R0 = model.R0Param;
v_max = 4.2;
v_min = 2.5;

Q = 2.9;
i_dis_max_soc = (soc - 3*socbound - z_min) ./ (deltaT / (3600*Q));
i_dis_rate = 30;
i_dis_max_vol = [];
p_dis_max = [];

k=1;
while k < length(soc(1:200000)) 
OCV = OCVfromSOCtemp(soc(k+deltaT),model);
i_dis_max_vol(k:k+deltaT) =  (OCV-R*ir(k+deltaT)-v_min)/(R0);

i_dis_max = min([i_dis_rate, i_dis_max_vol(k), i_dis_max_soc(k)]);
p_dis_max(k:k+deltaT) = i_dis_max * (OCV+R*ir(k+deltaT)-R0*i_dis_max);
k = k + deltaT*deltat;
end

close all;
plot(time(1:length(p_dis_max))/60,power(1:length(p_dis_max)),'LineWidth',2)
hold on
plot(time(1:length(p_dis_max))/60,p_dis_max,'LineWidth',2)
xlabel('Time (min)');
ylabel('Power (W)');
legend('Power profile','Power limit');
set(gca,'FontSize',14);

figure()
plot(time(1:length(p_dis_max))/60,i_dis_max_soc(1:length(p_dis_max)),'LineWidth',2);
hold on
plot(time(1:length(p_dis_max))/60,i_dis_max_vol(1:length(p_dis_max)),'LineWidth',2);
yline(30,'Color','#EDB120','LineWidth',2);
legend('SOC based','Voltage based','Rated current');
xlabel('Time (min)');
ylabel('Current limit (A)');
set(gca,'FontSize',14);
